---
title: CanvasRenderingContext2D.drawImage()
slug: Web/API/CanvasRenderingContext2D/drawImage
tags:
  - API
  - Canvas
  - CanvasRenderingContext2D
  - Method
  - Reference
---
<div>{{APIRef}}</div>

<p>The <code><strong>CanvasRenderingContext2D.drawImage()</strong></code> method of the Canvas 2D API provides different ways to draw an image onto the canvas.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">void <em>ctx</em>.drawImage(<em>image</em>, <em>dx</em>, <em>dy</em>);
void <em>ctx</em>.drawImage(<em>image</em>, <em>dx</em>, <em>dy</em>, <em>dWidth</em>, <em>dHeight</em>);
void <em>ctx</em>.drawImage(<em>image</em>, <em>sx</em>, <em>sy</em>, <em>sWidth</em>, <em>sHeight</em>, <em>dx</em>, <em>dy</em>, <em>dWidth</em>, <em>dHeight</em>);
</pre>

<p><img alt="drawImage" src="https://mdn.mozillademos.org/files/225/Canvas_drawimage.jpg" style="float: right;"></p>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>image</code></dt>
 <dd>An element to draw into the context. The specification permits any canvas image source ({{domxref("CanvasImageSource")}}), specifically, a {{domxref("CSSImageValue")}}, an {{domxref("HTMLImageElement")}}, an {{domxref("SVGImageElement")}}, an {{domxref("HTMLVideoElement")}}, an {{domxref("HTMLCanvasElement")}}, an {{domxref("ImageBitmap")}}, or an {{domxref("OffscreenCanvas")}}.</dd>
 <dt><code>sx</code> {{optional_inline}}</dt>
 <dd>The x-axis coordinate of the top left corner of the sub-rectangle of the source <code>image</code> to draw into the destination context. Note that this argument is not included in the 3- or 5-argument syntax.</dd>
 <dt><code>sy</code> {{optional_inline}}</dt>
 <dd>The y-axis coordinate of the top left corner of the sub-rectangle of the source <code>image</code> to draw into the destination context. Note that this argument is not included in the 3- or 5-argument syntax.</dd>
 <dt><code>sWidth</code> {{optional_inline}}</dt>
 <dd>The width of the sub-rectangle of the source <code>image</code> to draw into the destination context. If not specified, the entire rectangle from the coordinates specified by <code>sx</code> and <code>sy</code> to the bottom-right corner of the image is used. Note that this argument is not included in the 3- or 5-argument syntax.</dd>
 <dt><code>sHeight</code> {{optional_inline}}</dt>
 <dd>The height of the sub-rectangle of the source <code>image</code> to draw into the destination context. Note that this argument is not included in the 3- or 5-argument syntax.</dd>
 <dt><code>dx</code></dt>
 <dd>The x-axis coordinate in the destination canvas at which to place the top-left corner of the source <code>image</code>. Note that this argument is not included in the 3-argument syntax.</dd>
 <dt><code>dy</code></dt>
 <dd>The y-axis coordinate in the destination canvas at which to place the top-left corner of the source <code>image</code>. Note that this argument is not included in the 3-argument syntax.</dd>
 <dt><code>dWidth</code></dt>
 <dd>The width to draw the <code>image</code> in the destination canvas. This allows scaling of the drawn image. If not specified, the image is not scaled in width when drawn. Note that this argument is not included in the 3-argument syntax.</dd>
 <dt><code>dHeight</code></dt>
 <dd>The height to draw the <code>image</code> in the destination canvas. This allows scaling of the drawn image. If not specified, the image is not scaled in height when drawn. Note that this argument is not included in the 3-argument syntax.</dd>
</dl>

<h3 id="Exceptions_thrown">Exceptions thrown</h3>

<dl>
 <dt><code>INDEX_SIZE_ERR</code></dt>
 <dd>If the canvas or source rectangle width or height is zero.</dd>
 <dt><code>INVALID_STATE_ERR</code></dt>
 <dd>The image has no image data.</dd>
 <dt><code>TYPE_MISMATCH_ERR</code></dt>
 <dd>The specified source element isn't supported.</dd>
 <dt><code>NS_ERROR_NOT_AVAILABLE</code></dt>
 <dd>The image is not loaded yet. Use <code>.complete === true</code> and <code>.onload</code> to determine when it is ready.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<h3 id="Drawing_an_image_to_the_canvas">Drawing an image to the canvas</h3>

<p>This example draws an image to the canvas using the <code>drawImage()</code> method.</p>

<h4 id="HTML">HTML</h4>

<pre class="brush: html notranslate">&lt;canvas id="canvas"&gt;&lt;/canvas&gt;
&lt;div style="display:none;"&gt;
  &lt;img id="source"
       src="https://mdn.mozillademos.org/files/5397/rhino.jpg"
       width="300" height="227"&gt;
&lt;/div&gt;
</pre>

<h4 id="JavaScript">JavaScript</h4>

<p>The source image is taken from the coordinates (33, 71), with a width of 104 and a height of 124. It is drawn to the canvas at (21, 20), where it is given a width of 87 and a height of 104.</p>

<pre class="brush: js notranslate">const canvas = document.getElementById('canvas');
const ctx = canvas.getContext('2d');
const image = document.getElementById('source');

image.addEventListener('load', e =&gt; {
  ctx.drawImage(image, 33, 71, 104, 124, 21, 20, 87, 104);
});
</pre>

<h4 id="Result">Result</h4>

<p>{{ EmbedLiveSample('Drawing_an_image_to_the_canvas', 700, 180) }}</p>

<h3 id="Understanding_source_element_size">Understanding source element size</h3>

<p>The <code>drawImage()</code> method uses the source element's <em>intrinsic size in CSS pixels</em> when drawing.</p>

<p>For example, if you load an <code>Image</code> and specify the optional size parameters in its <a href="/en-US/docs/Web/API/HTMLImageElement/Image">constructor</a>, you will have to use the <code>naturalWidth</code> and <code>naturalHeight</code> properties of the created instance to properly calculate things like crop and scale regions, rather than <code>element.width</code> and <code>element.height</code>. The same goes for <code>videoWidth</code> and <code>videoHeight</code> if the element is a {{htmlelement("video")}} element, and so on.</p>

<h4 id="HTML_2">HTML</h4>

<pre class="brush: html notranslate">&lt;canvas id="canvas"&gt;&lt;/canvas&gt;</pre>

<h4 id="JavaScript_2">JavaScript</h4>

<pre class="brush: js notranslate">const canvas = document.getElementById('canvas');
const ctx = canvas.getContext('2d');

const image = new Image(60, 45); // Using optional size for image
image.onload = drawImageActualSize; // Draw when image has loaded

// Load an image of intrinsic size 300x227 in CSS pixels
image.src = 'https://mdn.mozillademos.org/files/5397/rhino.jpg';

function drawImageActualSize() {
  // Use the intrinsic size of image in CSS pixels for the canvas element
  canvas.width = this.naturalWidth;
  canvas.height = this.naturalHeight;

  // Will draw the image as 300x227, ignoring the custom size of 60x45
  // given in the constructor
  ctx.drawImage(this, 0, 0);

  // To use the custom size we'll have to specify the scale parameters
  // using the element's width and height properties - lets draw one
  // on top in the corner:
  ctx.drawImage(this, 0, 0, this.width, this.height);
}</pre>

<h4 id="Result_2">Result</h4>

<p>{{EmbedLiveSample('Understanding_source_element_size', 700, 260)}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('HTML WHATWG', "#dom-context-2d-drawimage", "CanvasRenderingContext2D: drawImage")}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.CanvasRenderingContext2D.drawImage")}}</p>

<h3 id="Gecko-specific_notes">Gecko-specific notes</h3>

<ul>
 <li>Support for flipping the image by using negative values for <code>sw</code> and <code>sh</code> was added in Gecko 5.0 {{geckoRelease("5.0")}}.</li>
 <li>Starting with {{geckoRelease("5.0")}}, <code>drawImage()</code> handles negative arguments in accordance with the specification, by flipping the rectangle around the appropriate axis.</li>
 <li>Specifying a <code>null</code> or <code>undefined</code> image when calling or <code>drawImage()</code> correctly throws a <code>TYPE_MISMATCH_ERR</code> exception starting with {{geckoRelease("5.0")}}.</li>
 <li>Prior to Gecko 7.0 {{ geckoRelease("7.0") }}, Firefox threw an exception if any of the coordinate values was non-finite or zero. As per the specification, this no longer happens.</li>
 <li>Gecko 9.0 {{ geckoRelease("9.0") }} now correctly supports CORS for drawing images across domains without <a href="/en/CORS_Enabled_Image#What_is_a_.22tainted.22_canvas.3F" title="en/CORS_Enabled_Image#What_is_a_.22tainted.22_canvas.3F">tainting the canvas</a>.</li>
 <li>Gecko 11.0 {{ geckoRelease("11.0") }} now allows SVG-as-an-image to be drawn into a canvas without <a href="/en/CORS_Enabled_Image#What_is_a_.22tainted.22_canvas.3F" title="en/CORS_Enabled_Image#What_is_a_.22tainted.22_canvas.3F">tainting the canvas</a>.</li>
</ul>

<h2 id="Notes">Notes</h2>

<ul>
 <li><code>drawImage()</code> only works correctly on an {{domxref("HTMLVideoElement")}} when its {{domxref("HTMLMediaElement.readyState")}}<strong> </strong>is greater than 1 (i.e., <strong>seek</strong> event fired after setting the <code>currentTime</code> property).</li>
 <li><code>drawImage()</code> will always use the source element's <em>intrinsic size in CSS pixels</em> when drawing, cropping, and/or scaling.</li>
 <li>In some older browser verisons, <code>drawImage()</code> will ignore all EXIF metadata in images, including the Orientation. This behavior is especially troublesome on iOS devices. You should detect the Orientation yourself and use <code>rotate()</code> to make it right.</li>
</ul>

<h2 id="See_also">See also</h2>

<ul>
 <li>The interface defining this method: {{domxref("CanvasRenderingContext2D")}}</li>
</ul>
